<?php

class bTraduction extends BackModule
{
    public function __construct(array $formvars = array())
    {
        parent::BackModule($formvars);
    }

    public function Listing($formvars = array())
    {
        $successImport = $successExport = $errorImport = $errorExport = [];

        $sql = "
            SELECT
                module_id,
                module_page,
                module_titre,
                module_bases
            FROM back_module bm
            WHERE bm.module_bases LIKE '%|%'
                AND bm.module_page IN ('".implode("', '", Tools::extractValue("module_page", $_SESSION["droit"]))."')
            ORDER BY module_titre
        ";

        $modules = $this->sql->getAll($sql);

        if (array_key_exists("export_fichier", $_POST) && !empty($_POST["module_id"]) && !empty($_POST["langue_id"])) {
            $sql = "
                SELECT module_page, module_bases
                FROM back_module
                WHERE module_id = ".mysql_real_escape_string($_POST["module_id"])."
            ";

            list($x) = $this->sql->getAll($sql);
            list($table, $tableNom) = explode("|", $x["module_bases"]);
            $modulePage = $x["module_page"];
            $class = "b".ucfirst($modulePage);

            $module = new $class();
            $module->tradOnly = true;
            $module->Form();

            $translateFields = array();

            foreach ($module->forms as &$f) {
                if (!empty($f->translate)) {
                    $translateFields[] = [
                        "title" => $f->title,
                        "name" => $f->name,
                        "wysiwyg" => !empty($f->tinyMCE),
                    ];
                }
            } unset($f);

            if (empty($translateFields)) {
                $errorExport[] = "Aucun champ de traduction dans ce module.";
            } else {
                $sql = "
                    SELECT
                        t.".$table."_id AS id,
                        tn_ori.langue_id AS ori_langue_id,
                        '".mysql_real_escape_string($_POST["langue_id"])."' AS langue_id,
                        ".implode("\n, ", array_reduce($translateFields, function($acc, $a) {
                            $acc[] = "tn." . $a["name"];
                            $acc[] = "tn_ori." . $a["name"] . " AS ori_" . $a["name"];
                            return $acc;
                        }, []))."
                    FROM $table t
                    INNER JOIN $tableNom tn_ori ON tn_ori." . $table . "_id = t." . $table . "_id
                        AND tn_ori.langue_id = ".LANGUE."
                    LEFT JOIN $tableNom tn ON tn." . $table . "_id = t." . $table . "_id
                        AND tn.langue_id = " . mysql_real_escape_string($_POST["langue_id"]) . "
                    WHERE (" . implode(" OR ", array_reduce($translateFields, function ($acc, $a) {
                        $acc[] = "NULLIF(tn." . $a["name"] . ", '') IS NULL";
                        return $acc;
                    }, [])) . ")
                ";

                $xs = $this->sql->getAll($sql);

                $entetes2 = Tools::extractValue("name", $translateFields);
                $entetes3 = Tools::extractValue("title", $translateFields);
                array_unshift($entetes2, "langue_id");
                array_unshift($entetes2, "id");
                array_unshift($entetes2, "mapping");
                array_unshift($entetes3, "Langue");
                array_unshift($entetes3, "Id");
                array_unshift($entetes3, "Entetes");

                $csv = new Csv(sys_get_temp_dir() . DS . "traductions_$modulePage.csv");

                $csv->writeData(["module", $modulePage]);
                $csv->writeData(["langue", $_POST["langue_id"]]);
                $csv->writeData($entetes2);
                $csv->writeData($entetes3);

                foreach ($xs as &$x) {
                    $id = array_shift($x);

                    $ligneModele = $ligneTrad = array();

                    array_map(function(&$k, &$v) use (&$ligneModele, &$ligneTrad) {
                        if (substr($k, 0, 4) == "ori_") {
                            $ligneModele[] = html_entity_decode($v);
                        } else {
                            $ligneTrad[] = html_entity_decode($v);
                        }
                    }, array_keys($x), $x);

                    array_unshift($ligneModele, $id);
                    array_unshift($ligneModele, "");
                    array_unshift($ligneTrad, $id);
                    array_unshift($ligneTrad, "");
                    $csv->writeData($ligneModele);
                    $csv->writeData($ligneTrad);

                } unset($x);

                $csv->getCsv(true);
                exit;
            }
        }

        if (!empty($_POST["import_fichier"])) {
            $csv = new Csv($_FILES["fichier_import"]["tmp_name"]);
            $csv->loadData();

            $entete1 = $csv->getNextLine();
            $entete2 = $csv->getNextLine();
            $entete3 = $csv->getNextLine();

            // Libellés informatifs pour le remplissage
            $entete4 = $csv->getNextLine();

            // Validation du format
            if (count($entete1) < 2) {
                $errorImport[] = "Validation du format (Ligne 1): Nombre de colonnes invalide : 2 requises";
            }

            if ($entete1[0] != "module") {
                $errorImport[] = "Validation du format (Ligne 1): Colonne 1 invalide : Valeur 'module' attendue";
            }

            if (!in_array($entete1[1], Tools::extractValue("module_page", $modules))) {
                $errorImport[] = "Validation du format (Ligne 1): Module non reconnu : " . $entete1[1];
            }

            if (count($entete2) < 2) {
                $errorImport[] = "Validation du format (Ligne 2): Nombre de colonnes invalide : 2 requises";
            }

            if ($entete2[0] != "langue") {
                $errorImport[] = "Validation du format (Ligne 2): Colonne 1 invalide : Valeur 'langue' attendue";
            }

            if (count($entete3) < 4) {
                $errorImport[] = "Validation du format (Ligne 3): Nombre de colonnes invalide : au moins 4 requises";
            }

            if ($entete3[0] != "mapping") {
                $errorImport[] = "Validation du format (Ligne 3): Colonne 1 invalide : Valeur 'mapping' attendue";
            }

            if ($entete3[1] != "id") {
                $errorImport[] = "Validation du format (Ligne 3): Colonne 2 invalide : Valeur 'id' attendue";
            }

            if ($entete3[2] != "langue_id") {
                $errorImport[] = "Validation du format (Ligne 3): Colonne 3 invalide : Valeur 'langue_id' attendue";
            }

            if (empty($errorImport)) {
                $langueIdImport = $entete2[1];
                $moduleImport = $entete1[1];

                $mapping = $entete3;
                array_shift($mapping);

                $dataImport = [];

                while ($c = $csv->getNextLine()) {
                    array_shift($c);

                    if ($c[1] != $langueIdImport) {
                        continue;
                    }

                    $dataImport[] = array_combine($mapping, $c);
                }

                $queries = [];

                foreach ($dataImport as &$d) {
                    $id = array_shift($d);
                    array_shift($d); // Colonne langue_id
                    $d = array_filter($d);

                    if (!empty($d)) {
                        // Il reste des valeurs

                        $e = $this->sql->getInit("
                            SELECT ".$moduleImport."_nom_id AS id
                            FROM ".$moduleImport."_nom
                            WHERE ".$moduleImport."_id = ".mysql_real_escape_string($id)."
                                AND langue_id = ".mysql_real_escape_string($langueIdImport)."
                        ");

                        $champs = [];
                        array_map(function(&$k, &$v) use (&$champs) {
                            $champs[] = "$k = '".mysql_real_escape_string($v)."'";
                        }, array_keys($d), $d);

                        if (empty($e)) {
                            // Création
                            $queries[] = "INSERT INTO ".$moduleImport."_nom SET " . implode(", \n", array_merge($champs, [
                                "langue_id = $langueIdImport",
                                $moduleImport."_id = $id",
                            ]));
                        } else {
                            // Mise à jour
                            $queries[] = "
                                UPDATE ".$moduleImport."_nom SET
                                    " . implode(", \n", $champs) . "
                                WHERE ".$moduleImport."_id = ".mysql_real_escape_string($id)."
                                    AND langue_id = ".mysql_real_escape_string($langueIdImport)
                            ;
                        }
                    }
                } unset($d);

                foreach ($queries as &$q) {
                    $this->sql->query($q);
                } unset($q);

                $successImport[] = "Import effectué.";
            }
        }

        $html = $this->displayPath();
        $langue = new Langue();
        $arrLangue = $langue->get(array(
            "all" => true,
        ));

        $html .= '
            <hr>
            <div>
                <h3>Exporter un fichier de traduction</h3>
                <br>
                <form method="post">
                    <label for="module_id">Module</label>
                    <select name="module_id" id="module_id">
                        '.array_reduce($modules, function($acc, $a) {
                            $acc .= '<option '.((!empty($_POST["module_id"]) && $_POST["module_id"] == $a["module_id"]) ? 'selected': '').' value="'.$a["module_id"].'">'.$a["module_titre"].'</option>';
                            return $acc;
                        }, "").'
                    </select>
                    &nbsp;
                    <label for="module">Langue</label>
                    <select name="langue_id" id="langue_id">
                        '.array_reduce($arrLangue, function($acc, $a) {
                            if ($a["langue_id"] != 1) {
                                $acc .= '<option '.((!empty($_POST["langue_id"]) && $_POST["langue_id"] == $a["langue_id"]) ? 'selected': '').' value="'.$a["langue_id"].'">'.$a["langue_nom"].'</option>';
                            }
                            return $acc;
                        }, "").'
                    </select>
                    &nbsp;
                    <button type="submit" name="export_fichier">OK</button>
                    '.(!empty($successExport) ?
                        '<div style="margin: 10px 0;font-size: 14px;line-height: 20px;;font-weight: 700;color: #068522"><span style="font-size: 1.5em;">&#128504;</span>&nbsp;'.implode("<br>", $successExport).'</div>' :
                        '').'
                    '.(!empty($errorExport) ?
                        '<div style="margin: 10px 0;font-size: 14px;line-height: 20px;;font-weight: 700;color: #850100"><span style="font-size: 1.5em;">&#10007;</span>&nbsp;' .implode("<br>", $errorExport).'</div>' :
                        '').'
                </form>
            </div>
            <hr>
            <h3>Importer un fichier de traduction</h3>
            <br>
            <form enctype="multipart/form-data" method="post" action="'.Tools::replaceQueryParams($_SERVER["REQUEST_URI"], array("type" => "html")).'">
                <input type="hidden" name="import_fichier" value="1">
                 <input type="file" name="fichier_import" id="fichier_import">
                &nbsp;
                <button>OK</button>
                '.(!empty($successImport) ?
                '<div style="margin: 10px 0;font-size: 14px;line-height: 20px;;font-weight: 700;color: #068522"><span style="font-size: 1.5em;">&#128504;</span>&nbsp;'.implode("<br>", $successImport).'</div>' :
                    '').'
                '.(!empty($errorImport) ?
                '<div style="margin: 10px 0;font-size: 14px;line-height: 20px;;font-weight: 700;color: #850100"><span style="font-size: 1.5em;">&#10007;</span>&nbsp;' .implode("<br>", $errorImport).'</div>' :
                '').'
            </form>
            <hr>
        ';

        return $html;
    }
}
