<?php

use Phinx\Migration\AbstractMigration;
use Phinx\Db\Adapter\MysqlAdapter;

class AddNewsletter extends AbstractMigration
{
    public function change()
    {
        $this
            ->table("newsletter", ['id' => false, 'primary_key' => ["newsletter_id"], 'engine' => "InnoDB", 'encoding' => "utf8", 'collation' => "utf8_general_ci", 'comment' => ""])
            ->addColumn('newsletter_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'identity' => 'enable', 'signed' => false])
            ->addColumn('newsletter_email', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'newsletter_id'])
            ->addColumn('newsletter_nom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'newsletter_email'])
            ->addColumn('newsletter_prenom', 'string', ['null' => false, 'default' => '', 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'newsletter_nom'])
            ->addColumn('newsletter_date_ajout', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'newsletter_prenom'])
            ->addColumn('newsletter_date_modif', 'datetime', ['null' => false, 'default' => '0000-00-00 00:00:00', 'after' => 'newsletter_date_ajout'])
            ->addColumn('newsletter_provenance', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'newsletter_date_modif'])
            ->addColumn('newsletter_civilite', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'newsletter_provenance'])
            ->addColumn('newsletter_ddn', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'newsletter_civilite'])
            ->addColumn('newsletter_cp', 'string', ['null' => false, 'limit' => 255, 'collation' => "utf8_general_ci", 'encoding' => "utf8", 'after' => 'newsletter_ddn'])
            ->addColumn('boutique_id', 'integer', ['null' => false, 'limit' => MysqlAdapter::INT_REGULAR, 'precision' => 10, 'after' => 'newsletter_cp', 'signed' => false])
            ->addForeignKey('boutique_id', 'boutique', 'boutique_id', array(
                'delete' => 'CASCADE',
                'update' => 'CASCADE'
            ))
            ->addIndex(['newsletter_email'], ['name' => "newsletter_email", 'unique' => true])
            ->addIndex(['boutique_id'], ['name' => "boutique_id", 'unique' => false])
            ->create();
    }
}
