<?php

/**
 * Class Gamme
 *
 * @property integer $gamme_id
 * @property integer $parent_id
 * @property integer $gamme_rang
 * @property integer $gamme_visible
 * @property string $gamme_nom_nom
 * @property string $gamme_nom_desc
 */
class Gamme extends Model
{

    const PROMOTIONS_MOMENT = 5;
    const NOUVEAUTES = 6;

    protected $table = 'gamme';

    /**
     * @param array $formvars
     * @param string $champs
     *
     * @return null
     */
    public function get($formvars = array(), $champs = "")
    {

        $sql = "SELECT *, c.parent_id, c.gamme_id, c.gamme_visible, c.gamme_image";
        if (!empty($formvars['products'])) {
            $sql .= ", COUNT(pc.produit_id) as nbProd";
        }

        $sql.=" FROM (gamme c)";
        if (empty($formvars['no_boutique'])) {
            $sql.=" INNER JOIN gamme_boutique gb ON(c.gamme_id = gb.gamme_id AND gb.boutique_id = '".Boutique::getInstance()->id."')";
        }
        $sql.=" INNER JOIN gamme_nom cn ON (c.gamme_id = cn.gamme_id AND cn.langue_id='" . Boutique::getInstance()->getLangue()->id . "')";


        if (!empty($formvars['products'])) {
            $sql.=" LEFT JOIN produit_gamme pc ON (pc.gamme_id = c.gamme_id)";
        }
        if (!empty($formvars['categorie_id'])) {
            $sql.=" LEFT JOIN categorie_gamme cg ON (c.gamme_id = cg.gamme_id)";
        }

        $sql.=" WHERE 1";

        if (!isset($formvars['gamme_visible'])) {
            $sql.=" AND c.gamme_visible = '1'";
            if (empty($formvars['no_boutique'])) {
                $sql.=" AND gb.gamme_boutique_statut_id = '1'";
            }
        }

        if (!empty($formvars['categorie_id'])) {
            $sql .= " AND cg.categorie_id = '" . $formvars['categorie_id'] . "'";
        }

        if (isset($formvars['gamme_visible'])) {
            $sql .= " AND c.gamme_visible = '" . $formvars['gamme_visible'] . "'";
        }

        if (isset($formvars['gamme_menu'])) {
            $sql .= " AND c.gamme_menu = '" . $formvars['gamme_menu'] . "'";
        }

        if (!empty($formvars['gamme_accueil_statut'])) {
            $sql .= " AND c.gamme_accueil_statut = '" . $formvars['gamme_accueil_statut'] . "'";
        }

        if (!empty($formvars['gamme_id'])) {
            if (is_array($formvars['gamme_id'])) {
                $sql .= " AND c.gamme_id IN (" . implode(',', $formvars['gamme_id']) . ")";
            } else {
                $sql .= " AND c.gamme_id = '" . $formvars['gamme_id'] . "'";
            }
        }
        if (!empty($formvars['not_gamme_id'])) {
            $sql .= " AND c.gamme_id <> '" . $formvars['not_gamme_id'] . "'";
        }
        if (!empty($formvars['parent_id'])) {
            $sql .= " AND c.parent_id = '" . $formvars['parent_id'] . "'";
        }
        if (!empty($formvars['only_parent'])) {
            $sql .= " AND c.parent_id IS NULL";
        }
        if (!empty($formvars['no_parent'])) {
            $sql .= " AND c.parent_id IS NOT NULL";
        }
        if (!empty($formvars['gamme_nom_url'])) {
            $sql .=" AND cn.gamme_nom_url = '" . $formvars['gamme_nom_url'] . "'";
        }

        $sql.=" GROUP BY c.gamme_id";
        if (!empty($formvars['products'])) {
            $sql .= " HAVING nbProd > 0";
        }

        if (!empty($formvars['order'])) {
            $sql .= " ORDER BY RAND()";
        } else {
            $sql .= " ORDER BY c.gamme_rang";
        }

        if (!empty($formvars['limit'])) {
            $sql .= " LIMIT " . $formvars['limit'];
        }

        if (empty($champs)) {
            return $this->sql->getAll($sql);
        } else {
            $result = $this->sql->getOne($sql);
            return $result[$champs];
        }
    }
}
