/**
 * Created by Gaetan on 12/10/2015.
 */

$.fn.flashsale = function(options) {

    if(options == undefined || typeof(options) != 'object'){
        options = {};
    }

    if($(this).attr('rel')){
        options['time'] = $(this).attr('rel');
    } else {
        return false;
    }

    var locales = {
        'fr': {
            'd': 'jrs',
            'h': 'h',
            'i': 'min',
            's': 's',
        }
    }

    var defaultConfig = {
        'locale': 'fr'
    };

    var actualLocale = null;

    if(options['locale'] != undefined){
        actualLocale = options['locale'];
    } else {
        actualLocale = defaultConfig['locale']
    }

    var destTime = null;
    var duration = null;
    var timer = null;
    var actualTime = new Date();

    $($(this).selector).each(function(i,e){
        var destDate = Date.parse($(this).attr('rel').replace(' ','T'));
        destTime = new Date(destDate);
        duration = (destTime - actualTime) / 1000;
        timer = getFlashSaleTimer(duration);
        var countdown = $('<div class="flashsale-countdown countdown">' +
            '<div class="flashsale-days">' +
            '<span class="flashsale-days-number">' + timer.days + '</span>' +
            '<span class="flashsale-days-label">' + locales[actualLocale]['d'] + '</span> ' +
            '</div>' +
            '<div class="flashsale-hours">' +
            '<span class="flashsale-hours-number">' + timer.hours + '</span>' +
            '<span class="flashsale-hours-label">' + locales[actualLocale]['h'] + '</span> ' +
            '</div>' +
            '<div class="flashsale-mins">' +
            '<span class="flashsale-mins-number">' + timer.minutes + '</span>' +
            '<span class="flashsale-mins-label">' + locales[actualLocale]['i'] + '</span> ' +
            '</div>' +
            '<div class="flashsale-secs">' +
            '<span class="flashsale-secs-number">' + timer.remainingSeconds + '</span>' +
            '<span class="flashsale-secs-label">' + locales[actualLocale]['s'] + '</span>' +
            '</div>' +
            '</div>');
        $(e).append($(countdown));
    });

    var that = $(this);
    var interval = setInterval(function(){
        $($(that).selector).each(function(i,e) {
            var destDate = Date.parse($(this).attr('rel').replace(' ','T'));
            destTime = new Date(destDate);
            actualTime = new Date();
            duration = (destTime - actualTime) / 1000;
            //console.log(duration);
            timer = getFlashSaleTimer(duration);

            $(e).find('.flashsale-days-number').html(timer['days']);
            $(e).find('.flashsale-hours-number').html(timer['hours']);
            $(e).find('.flashsale-mins-number').html(timer['minutes']);
            $(e).find('.flashsale-secs-number').html(timer['remainingSeconds']);
        });
    }, 1000);

}

function getFlashSaleTimer(duration){
    var timer = {};
    timer['days']               = Math.floor(duration/24/60/60),
    timer['hoursLeft']          = Math.floor((duration) - (timer['days']*86400)),
    timer['hours']              = Math.floor(timer['hoursLeft']/3600);
    timer['minutesLeft']        = Math.floor((timer['hoursLeft']) - (timer['hours']*3600));
    timer['minutes']            = Math.floor(timer['minutesLeft']/60);
    timer['remainingSeconds']  = Math.floor(duration % 60);

    if (timer['hours'] < 10) {
        timer['hours'] = "0" + timer['hours'];
    }
    if (timer['minutes'] < 10) {
        timer['minutes'] = "0" + timer['minutes'];
    }
    if (timer['remainingSeconds'] < 10) {
        timer['remainingSeconds'] = "0" + timer['remainingSeconds'];
    }

    return timer;
}